

int main( int argc, char ** argv ) {
	char rx;
	char togo;
	char webcam_buffer[256];
	char state;
	int i,j;
	
	while (!(UCSRA & (1<<RXC))){}
		rx = UDR;	
		
		switch(state){
			case 0: 
				//no packet header rcv, wait for header:
				if (rx == 0xF9)
					state = 1;
				//else: do nothing
				break;
			case 1:
				//we got a F9
				if (rx == 0x83)
					state = 2; //we have a data packet
				else if (rx == 0xF9){
					state = 1; //this is the real start byte
					//printf("read(0x%02x)\n",rx);
					//printf("out of sync .. packet=%d, j=%d\n", webcam_buffer_empty,j);
					//printf("buf before: %02x %02x %02x %02x\n",
					//	 webcam_buffer[j-3],webcam_buffer[j-2],
					//	 webcam_buffer[j-1],webcam_buffer[j-0]);
				}else{
					//printf("read(0x%02x)\n",rx);
					//printf("@packet:%d: bytepos:%d: ERR[0x%02x]\n",webcam_buffer_empty,j,rx);
					state =0;
				}
				break;
			case 2:
				//now we expect EF
				if (rx == 0xEF)
					state = 3;
				else{
					//printf("read(0x%02x)\n",rx);
					//printf("ERR: no 0xEF!->0x%02x\n", rx);
					state = 0;
				}
				break;
			case 3: 	
				//next byte is frame len:
				togo = (rx-1)/2; //rx/2
				//printf("len=%d\n",togo);
				if (togo != 31 && togo != 13) printf("len=%d\n",togo);
				state = 4;
				break;
			case 4:
				//if we got 0x90 this is a ackAck packet
				if (rx == 0x90){
					skip  = 5; //skip next 5byte (=total 6 skipped)
					state = 5; //goto skip
					
				}else{
					//this is 1 data byte -> write:
					webcam_buffer[j] = rx;
					//printf("OUT[%03d] 0x%02x\n",j,rx);
					j++;
					
					togo  = togo - 1; //we have read already 1 byte from frame
					state = 6;  //goto handle data
				}
				break;
			case 5:
				//skip acks
				skip--;
				if (skip == 0){
					togo = togo - 5; //we have read already 6 bytes from frame
					state = 6; //goto handle data
				}
				break;
			case 6:
				//now sample data:
				webcam_buffer[j] = rx;
				//printf("OUT[%03d] 0x%02x\n",j,rx);
				j++;
				togo--;
				if (togo == 0)
					state = 7;
				break;
			case 7:
				//data is there now we read checksum:
				//ignore CS...
				//printf("CSUM=%02x\n",rx);
				state = 8;
				break;
			case 8: 
				//we have frame end:
				if (rx != 0xF9){
					printf("FRAME ERROR! @packet:%d: (0x%02x)\n",webcam_buffer_empty,rx);
				}
				//printf("EOF=%d\n\n",rx);
				state = 0;
				break;
			default:
				printf("oh no .... this should never ever happen :-X\n");
		}
				
	}